import argparse
from collections import Counter
from PIL import Image, ImageSequence
import os
from itertools import product

def split(img,L,h,d,dir_out):
    nom_fichier = 'Composite-TMA.tif'
    name, ext = os.path.splitext(nom_fichier)

    grid = list(product(range(0, h - h % d, d), range(0, L - L % d, d)))
    
    for k, im_fra in enumerate(ImageSequence.Iterator(img)):
        for i, j in grid:
            cropped_ims = ImageSequence.all_frames(im_fra, lambda im_frame: im_frame.crop((i, j, i+d, j+d)))
            out = os.path.join(dir_out, f'{name}_{i}_{j}{ext}')
            cropped_ims[0].save(out, save_all=True, append_images=cropped_ims[1:])

    # grid = list(product(range(0, h - h % d + 1920 - 1536, d), range(0, w - w % d + 1920 - 1536, d)))
    # for k, im_fra in enumerate(ImageSequence.Iterator(img)):
    #      for i, j  in grid:
    #            cropped_ims = ImageSequence.all_frames(im_fra, lambda im_frame: im_frame.crop((i, j, i+d, j+d)))
    #            im1 = Image.Image.split(cropped_ims)
    #            for k in range(32):
    #                out = os.path.join(dir_out, f'{name}_{k}_{i}_{i+d}__{j}_{j+d}{ext}')
        

def Diviser(im, largeur_ligne, hauteur_ligne, image_path):
    
     im_largeur, im_hauteur = im.size

     Lignes = int(im_largeur / largeur_ligne) + 1 
     cols = int(im_hauteur / hauteur_ligne) + 1 

     # Lignes = int(im_largeur / largeur_ligne)  
     # cols = int(im_hauteur / hauteur_ligne) 
     n = 0

     for i in range(0, cols):

         for j in range(0, Lignes):
             b = (j * largeur_ligne, i * hauteur_ligne, j * largeur_ligne +largeur_ligne, i * hauteur_ligne + hauteur_ligne)
             #b = (j * Lignes, i * cols, j * Lignes +Lignes, i * cols + cols)

             sortie = im.crop(b)
             sortie_path = image_path.split(".")[0] + "_" + str(i*largeur_ligne)+"_" + str(j*hauteur_ligne) + ".tif"
             print("Exportation d'une tile d'image: " + sortie_path)
             sortie.save(sortie_path)
             n += 1


def determine_bg_color(im):
    print("Determiner la couleur de fond")
    im_largeur, im_hauteur = im.size
    rgb_im = im.convert('RGBA')
    les_couleurs= []

    regions = [[(0, 0), (im_largeur, im_hauteur / 10)],[(0, 0), (im_largeur / 10, im_hauteur)],
             [(im_largeur * 9 / 10, 0), (im_largeur, im_hauteur)],[(0, im_hauteur * 9 / 10), (im_largeur, im_hauteur)]]

    for zone in regions:
        deb = zone[0]
        fin = zone[1]

        for x in range(int(deb[0]), int(fin[0])):
            for y in range(int(deb[1]), int(fin[1])):
                pix = rgb_im.getpixel((x, y))
                les_couleurs.append(pix)

    return Counter(les_couleurs).most_common(1)[0][0]


# def main():
#     parser = argparse.ArgumentParser(description="Split une image en lignes et en colonnes.")
#     parser.add_argument("image_path", nargs=1, help="Le chemin de l'image vers split.")
#     parser.add_argument("Lignes", type=int, default=4,help="En combien de lignes diviser l'image (division horizontale).")
#     parser.add_argument("cols", type=int, default=4,help="En combien de colonnes diviser l'image (division verticale).")
#     parser.add_argument("c", "carre", action="store_true",help="Si l'image doit être redimensionnée dans un carre avant splitting.")
#     args = parser.parse_args()
#     image_path = args.image_path[0]
#     im = Image.open(image_path)
#     im_largeur, im_hauteur = im.size
#     min_dimension = min(im_largeur, im_hauteur)
#     max_dimension = max(im_largeur, im_hauteur)

#     if args.square:
#         print("Redimensionner l'image en carre")
#         bg_color = determine_bg_color(im)
#         print("La couleur de fond est... " + str(bg_color))
#         im_r = Image.new("RGBA", (max_dimension, max_dimension), bg_color)
#         offset = int((max_dimension - min_dimension) / 2)
#         if im_largeur > im_hauteur:
#             im_r.paste(im, (0, offset))
#         else:
#             im_r.paste(im, (offset, 0))
#         split(im_r, args.Lignes, args.cols, image_path)
#         print("Exportation d'une image redimensionnee")
#         im_r.save(image_path + "_carre.tif")
#     else:
#         split(im, args.lignes, args.cols, image_path)
#     print("fait!")

